classification
Title: PEP 570: Python Positional-Only Parameters
Type: Stage: resolved
Components: Interpreter Core Versions: Python 3.8
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: pablogsal Nosy List: ericvw, gousaiyang, lukasz.langa, pablogsal, serhiy.storchaka, vstinner, willingc
Priority: high Keywords: patch

Created on 2019-04-06 01:06 by pablogsal, last changed 2021-04-07 19:32 by pablogsal. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 12701 closed pablogsal, 2019-04-06 01:06
PR 12942 merged gvanrossum, 2019-04-24 17:20
PR 13202 merged pablogsal, 2019-05-08 17:38
PR 13706 merged pablogsal, 2019-05-31 18:00
PR 25235 merged gousaiyang, 2021-04-06 23:52
PR 25259 merged gousaiyang, 2021-04-07 19:12
PR 25260 merged gousaiyang, 2021-04-07 19:14
Messages (14)
msg339521 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-06 01:06
This issue will serve to track development and PRs for the implementation of PEP 570: Python Positional-Only Parameters.
msg340141 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-13 01:22
I will separate the work in two Pull Request (maybe more). The implementation of the PEP will be done in PR12701 and the documentation and other additions will be done in future Pull Requests to keep things more manageable.
msg340246 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2019-04-15 09:25
PR 12701 makes breaking changes in the inspect module.

Currently we have two sets of APIs in the inspect module: old deprecated API that do not support keyword-only arguments, and new *full* API that supports them. Even many years since 3.0 the old API still has not been removed. Adding support for positional-only arguments needs changes of the same order as adding support of keyword-only arguments. It means deprecating the current API and introducing a new (*fuller*?) API. This is a slow process for many releases. We could also take opportunity to redesign APIs completely instead of just adding new parameters and fields.

I suggest to remove all breaking changes in the inspect module and defer them to the separate issue. This perhaps will need a discussion on Python-Dev, and maybe not one.
msg340247 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-15 09:32
It seems like deprecating or removing "old" inspect functions is an issue. An option would be to raise an error if these functions is used on a function which has at least one positional argument.
msg341041 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-29 03:36
Łukasz, are you ok if we include this one in alpha4 as we were discussing in the PRs? If you are happy with that I will merge it so there is early testing and then we can keep working on the documentation and minor details for the next stage. If not, please, unmark it as a release blocker.
msg341071 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-29 12:15
Opened https://bugs.python.org/issue36751 to track changes in the inspect module.
msg341072 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-29 12:37
New changeset 8c77b8cb9188165a123f2512026e3629bf03dc9b by Pablo Galindo in branch 'master':
bpo-36540: PEP 570 -- Implementation (GH-12701)
https://github.com/python/cpython/commit/8c77b8cb9188165a123f2512026e3629bf03dc9b
msg341073 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-04-29 12:51
The implementation has been merged, so I will remove the "release blocker". We are still missing the documentation and the final changes to the inspect module.
msg341119 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2019-04-29 19:59
+1
msg343835 - (view) Author: Carol Willing (willingc) * (Python committer) Date: 2019-05-28 23:45
New changeset b76302ddd0896cb39ce69909349b53db6e7776e2 by Carol Willing (Pablo Galindo) in branch 'master':
bpo-36540: Documentation for PEP570 - Python positional only arguments (#13202)
https://github.com/python/cpython/commit/b76302ddd0896cb39ce69909349b53db6e7776e2
msg343836 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-05-28 23:49
Closing this. Will reopen if we realize we missed something.
msg390467 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2021-04-07 19:06
New changeset 58d72cab89cf9652acc0bf0007aa20b2bcc98499 by Saiyang Gou in branch 'master':
bpo-36540: Improve doc of function definition regarding positional-only arguments (GH-25235)
https://github.com/python/cpython/commit/58d72cab89cf9652acc0bf0007aa20b2bcc98499
msg390470 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2021-04-07 19:32
New changeset 4554ab435727a0f3b6441c9c1a8d3fe6534433c7 by Saiyang Gou in branch '3.8':
[3.8] bpo-36540: Improve doc of function definition regarding positional-only arguments (GH-25235) (GH-25260)
https://github.com/python/cpython/commit/4554ab435727a0f3b6441c9c1a8d3fe6534433c7
msg390471 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2021-04-07 19:32
New changeset 3b1cf202976d9590d5b453c47b883f2e7cd1a7a5 by Saiyang Gou in branch '3.9':
[3.9] bpo-36540: Improve doc of function definition regarding positional-only arguments (GH-25235) (GH-25259)
https://github.com/python/cpython/commit/3b1cf202976d9590d5b453c47b883f2e7cd1a7a5
History
Date User Action Args
2021-04-07 19:32:56pablogsalsetmessages: + msg390471
2021-04-07 19:32:32pablogsalsetmessages: + msg390470
2021-04-07 19:14:52gousaiyangsetpull_requests: + pull_request23996
2021-04-07 19:12:18gousaiyangsetpull_requests: + pull_request23995
2021-04-07 19:06:51pablogsalsetmessages: + msg390467
2021-04-06 23:52:52gousaiyangsetnosy: + gousaiyang

pull_requests: + pull_request23973
2019-05-31 18:00:24pablogsalsetpull_requests: + pull_request13593
2019-05-28 23:49:45pablogsalsetstatus: open -> closed
resolution: fixed
messages: + msg343836

stage: patch review -> resolved
2019-05-28 23:45:35willingcsetnosy: + willingc
messages: + msg343835
2019-05-08 17:38:48pablogsalsetpull_requests: + pull_request13113
2019-04-29 19:59:08lukasz.langasetmessages: + msg341119
2019-04-29 12:51:10pablogsalsetmessages: + msg341073
2019-04-29 12:50:07pablogsalsetpriority: release blocker -> high
2019-04-29 12:37:13pablogsalsetmessages: + msg341072
2019-04-29 12:15:04pablogsalsetmessages: + msg341071
2019-04-29 03:36:59pablogsalsetmessages: + msg341041
2019-04-29 03:32:47pablogsalsetpriority: normal -> release blocker
nosy: + lukasz.langa
2019-04-24 17:20:01gvanrossumsetpull_requests: + pull_request12866
2019-04-15 09:32:00vstinnersetnosy: + vstinner
messages: + msg340247
2019-04-15 09:25:19serhiy.storchakasetmessages: + msg340246
2019-04-13 01:22:22pablogsalsetmessages: + msg340141
2019-04-06 04:41:43serhiy.storchakasetnosy: + serhiy.storchaka
2019-04-06 01:12:08ericvwsetnosy: + ericvw
2019-04-06 01:06:36pablogsalsetkeywords: + patch
stage: patch review
pull_requests: + pull_request12625
2019-04-06 01:06:03pablogsalcreate